# $Revision: 1.47 $, $Date: 2012/01/22 12:03:29 $
# TODO
# - bundled and modified software:
#  - pexpect-0.999 http://pexpect.sourceforge.net/
#
# Conditional build:
%bcond_with	ksmarttray	# build ksmarttray (KDE3)

%define	module smart
Summary:	Next generation package handling tool
Summary(pl.UTF-8):	Narzędzie do obsługi pakietów nowej generacji
Name:		smart
Version:	1.4.1
Release:	1
License:	GPL v2+
Group:		Applications/System
Source0:	http://launchpad.net/smart/trunk/%{version}/+download/%{name}-%{version}.tar.bz2
# Source0-md5:	573ef32ba177a6b3c4bf7ef04873fcb6
Source1:	%{name}-distro.py
Source2:	%{name}.desktop
Source3:	%{name}-kde.desktop
Source4:	th.channel
Source5:	th-archive.channel
Source6:	th-multilib.channel
Source7:	th-obsolete.channel
Source8:	th-ready.channel
Source9:	th-test.channel
Patch0:		%{name}-syslibs.patch
Patch1:		%{name}-pyc.patch
Patch4:		%{name}-missingok.patch
Patch5:		%{name}-pycurl-segfaults.patch
URL:		http://labix.org/smart/
BuildRequires:	gettext-devel
%{?with_kde:BuildRequires:	kdelibs-devel}
BuildRequires:	libstdc++-devel
BuildRequires:	python-devel >= 1:2.3
BuildRequires:	python-modules
BuildRequires:	rpm-pythonprov
BuildRequires:	sed >= 4.0
Requires:	python-cElementTree
Requires:	python-elementtree
Requires:	python-rpm
%pyrequires_eq  python-modules
Suggests:	gksu
Suggests:	smart-config
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Smart Package Manager is a next generation package handling tool.

%description -l pl.UTF-8
Smart Package Manager to narzędzie do obsługi pakietów nowej
generacji.

%package update
Summary:	Allows execution of 'smart update' by normal users (suid)
Summary(pl.UTF-8):	Pakiet (suid) pozwalający wykonywać "smart update" zwykłym użytkownikom
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}

%description update
Allows execution of 'smart update' by normal users through a special
suid command.

%description update -l pl.UTF-8
Ten pakiet pozwala wykonywać "smart update" zwykłym użytkownikom
poprzez specjalne polecenie suid.

%package gui
Summary:	Graphical user interface for the Smart Package Manager
Summary(pl.UTF-8):	Graficzny interfejs użytkownika do zarządcy pakietów Smart
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	gksu
Requires:	python-pygtk-gtk

%description gui
Graphical user interface for the Smart Package Manager.

%description gui -l pl.UTF-8
Graficzny interfejs użytkownika do zarządcy pakietów Smart.

%package -n ksmarttray
Summary:	KDE tray program for watching updates with Smart Package Manager
Summary(pl.UTF-8):	Program zasobnika KDE do oglądania uaktualnień przy użyciu zarządcy pakietów Smart
Group:		Applications/System
Requires:	smart-update = %{version}-%{release}

%description -n ksmarttray
KDE tray program for watching updates with Smart Package Manager.

%description -n ksmarttray -l pl.UTF-8
Program zasobnika KDE do oglądania uaktualnień przy użyciu zarządcy
pakietów Smart.

%description -n ksmarttray -l pt.UTF-8
Programa tray do KDE para verificar atualizações com o Smart Package
Manager.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch4 -p1
#%patch5 -p0

# %{_libdir} is hardcoded
%{__sed} -i -e's,/usr/lib/,%{_libdir}/,' smart/const.py

rm -r smart/util/elementtree
rm -r smart/util/celementtree
rm smart/util/optparse.py

%build
# CC/CFLAGS is only for arch packages - remove on noarch packages
CC="%{__cc}" \
CFLAGS="%{rpmcflags}" \
%{__python} setup.py build

# smart-update
%{__make} -C contrib/smart-update \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags}"

%if %{with ksmarttray}
# ksmarttray
cd contrib/ksmarttray
%{__make} -f admin/Makefile.common

%configure \
%if "%{_lib}" == "lib64"
	--enable-libsuffix=64 \
%endif
	--%{?debug:en}%{!?debug:dis}able-debug%{?debug:=full} \
	--with-qt-libraries=%{_libdir}
%{__make}
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir},%{_libdir}/smart} \
	$RPM_BUILD_ROOT/var/lib/smart/{channels,packages} \
	$RPM_BUILD_ROOT/etc/smart/channels

%{__python} setup.py install \
	--skip-build \
	--optimize=2 \
	--root=$RPM_BUILD_ROOT

cp -f contrib/smart-update/smart-update $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_desktopdir}/%{name}.desktop
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_desktopdir}/%{name}-kde.desktop
install -p smart/interfaces/images/smart.png $RPM_BUILD_ROOT%{_pixmapsdir}/smart.png
# Currently needs to hardcode %{_libdir}, as this is hardcoded in the
# code, too.
install -p %{SOURCE1} $RPM_BUILD_ROOT%{_libdir}/smart/distro.py

%if %{with ksmarttray}
%{__make} -C contrib/ksmarttray install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%define	_pld_multilib_conf %{nil}
%ifarch i486 i686 ppc sparc alpha athlon
	%define		_ftp_arch	%{_target_cpu}
%endif
%ifarch %{x8664}
	%define		_ftp_arch	x86_64
	%define		_pld_multilib_conf %{SOURCE6}
%endif
%ifarch i586
	%define		_ftp_arch	i486
%endif
%ifarch pentium2 pentium3 pentium4
	%define		_ftp_arch	i686
%endif

for f in %{SOURCE4} %{SOURCE5} %{SOURCE7} %{SOURCE8} %{SOURCE9} %{_pld_multilib_conf}; do
	ff=$(basename $f)
	%{__sed} -e 's|%%ARCH%%|%{_ftp_arch}|g' $f >$RPM_BUILD_ROOT/etc/smart/channels/$ff
done

mv -f $RPM_BUILD_ROOT%{_datadir}/locale/{es_ES,es}

touch $RPM_BUILD_ROOT/var/lib/smart/packages/{cache,config}

%find_lang %{name}
%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc HACKING README LICENSE TODO IDEAS
%dir /etc/smart/channels
%attr(644,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/smart/channels/th*.channel
%attr(755,root,root) %{_bindir}/smart
%{_mandir}/man8/smart.8*
%{_libdir}/smart
%dir /var/lib/smart
%dir /var/lib/smart/channels
%dir /var/lib/smart/packages
%ghost /var/lib/smart/packages/cache
%ghost /var/lib/smart/packages/config

%attr(755,root,root) %{py_sitedir}/%{module}/ccache.so
%attr(755,root,root) %{py_sitedir}/%{module}/util/cdistance.so
%attr(755,root,root) %{py_sitedir}/%{module}/util/ctagfile.so
%attr(755,root,root) %{py_sitedir}/%{module}/backends/deb/_base.so
%attr(755,root,root) %{py_sitedir}/%{module}/backends/deb/cdebver.so
%attr(755,root,root) %{py_sitedir}/%{module}/backends/rpm/crpmver.so

%dir %{py_sitedir}/%{module}
%{py_sitedir}/%{module}/*.py[co]
%dir %{py_sitedir}/%{module}/backends
%{py_sitedir}/%{module}/backends/*.py[co]
%dir %{py_sitedir}/%{module}/backends/deb
%{py_sitedir}/%{module}/backends/deb/*.py[co]
%dir %{py_sitedir}/%{module}/backends/rpm
%{py_sitedir}/%{module}/backends/rpm/*.py[co]
%dir %{py_sitedir}/%{module}/backends/slack
%{py_sitedir}/%{module}/backends/slack/*.py[co]
%dir %{py_sitedir}/%{module}/channels
%{py_sitedir}/%{module}/channels/*.py[co]
%dir %{py_sitedir}/%{module}/commands
%{py_sitedir}/%{module}/commands/*.py[co]
%dir %{py_sitedir}/%{module}/interfaces
%{py_sitedir}/%{module}/interfaces/*.py[co]
%dir %{py_sitedir}/%{module}/interfaces/images
%{py_sitedir}/%{module}/interfaces/images/*.py[co]
%{py_sitedir}/%{module}/interfaces/images/*.png
%dir %{py_sitedir}/%{module}/interfaces/text
%{py_sitedir}/%{module}/interfaces/text/*.py[co]
%dir %{py_sitedir}/%{module}/plugins
%{py_sitedir}/%{module}/plugins/*.py[co]
%dir %{py_sitedir}/%{module}/util
%{py_sitedir}/%{module}/util/*.py[co]
%if "%{py_ver}" > "2.4"
%{py_sitedir}/smart-%{version}-*.egg-info
%endif

%files update
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/smart-update

%files gui
%defattr(644,root,root,755)
%dir %{py_sitedir}/%{module}/interfaces/gtk
%{py_sitedir}/%{module}/interfaces/gtk/*.py[co]
%dir %{py_sitedir}/%{module}/interfaces/qt
%{py_sitedir}/%{module}/interfaces/qt/*.py[co]
%dir %{py_sitedir}/%{module}/interfaces/qt4
%{py_sitedir}/%{module}/interfaces/qt4/*.py[co]
%{_desktopdir}/smart.desktop
%{_desktopdir}/smart-kde.desktop
%{_pixmapsdir}/smart.png

%dir %{py_sitedir}/%{module}/backends/arch
%{py_sitedir}/%{module}/backends/arch/*.py[co]

%if %{with kde}
%files -n ksmarttray
%defattr(644,root,root,755)
%attr(775,root,root) %{_bindir}/ksmarttray
%{_datadir}/apps/ksmarttray
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: smart.spec,v $
Revision 1.47  2012/01/22 12:03:29  baggins
- undefine multilib_conf by default

Revision 1.46  2012/01/22 11:57:33  baggins
- rel 1
- added default th channels

Revision 1.45  2012/01/21 21:53:27  baggins
- 1.4.1
- updated patches
- removed obsolete archscore patch

Revision 1.44  2011/06/02 06:34:25  uzsolt
- gui subpackage requires gksu (in desktop file: Exec=gksu ...)

Revision 1.43  2011/03/24 13:42:12  glen
- rename kde bcond to ksmarttray

Revision 1.42  2011/03/24 13:39:41  glen
- smart-kde.desktop is not intrusive, so don't bcond it (see also r1.31)

Revision 1.41  2011/03/24 13:30:28  glen
- updated to 1.3.1

Revision 1.40  2010/09/21 19:00:15  glen
- release 7

Revision 1.39  2010/07/08 08:47:07  arekm
- release 6

Revision 1.38  2010/05/15 00:06:27  sparky
- BR: gettext-devel, python-modules, rpm-pythonprov

Revision 1.37  2010/05/12 17:54:21  baggins
- rel 5
- revert kde bcond (doesn't build with kde4/kde4-kde3support)

Revision 1.36  2010/05/11 21:15:53  baggins
- rel 4
- desktop file cleanup

Revision 1.35  2008/10/03 18:04:48  arekm
- release 3

Revision 1.34  2008-02-22 19:56:52  czarny
- conditional smart-kde.desktop file

Revision 1.33  2007-12-26 16:03:54  glen
- add /var/lib/smart/{channels,packages} dirs, and cache,config ghostfiles

Revision 1.32  2007-12-26 14:24:00  glen
- S: smart-config

Revision 1.31  2007-12-25 19:49:33  glen
- smart-kde.desktop is non-intrusive (it is void on non-kde desktops)

Revision 1.30  2007-11-26 20:58:59  glen
- revert backtick exec from kde desktop file; rel 2

Revision 1.29  2007-11-15 16:17:11  patrys
- full release 1

Revision 1.28  2007/10/10 16:08:03  patrys
- upstream patch to prevent crashes inside libcurl

Revision 1.27  2007/10/09 14:27:10  patrys
- fix es_ES locale
- add missingok patch to parse our channels

Revision 1.26  2007/10/09 13:50:58  patrys
- 0.52

Revision 1.25  2007/09/16 02:39:59  emes
- added Suggests gksu

Revision 1.24  2007/07/30 17:29:08  patrys
- gui works

Revision 1.23  2007/07/30 17:03:09  patrys
- "fix" gui (dir structure broken by design)

Revision 1.22  2007/07/30 16:26:38  patrys
- 0.51
- patch1 applied upstream (with changes)

Revision 1.21  2007/03/15 11:03:27  czarny
- added patch for am110

Revision 1.20  2007/03/15 10:49:20  czarny
- up to 0.50
- added patch to fix work on rpm 4.4.7

Revision 1.19  2007/02/12 22:09:15  glen
- tabs in preamble

Revision 1.18  2007/02/12 01:06:32  baggins
- converted to UTF-8

Revision 1.17  2006/10/08 14:54:22  qboosh
- kde bcond cleanup

Revision 1.16  2006/09/20 14:34:03  piti
- removed duplicated description -l pt

Revision 1.15  2006/09/20 08:21:42  czarny
- added missing dirs in %{py_sitescriptdir}
- rel 0.2

Revision 1.14  2006/09/18 20:54:34  glen
- don't assume compressed manuals

Revision 1.13  2006/09/18 20:31:37  czarny
- typo

Revision 1.12  2006/09/18 20:21:43  czarny
- up to 0.42
- removed patches already included in this rel
- updated files
- added man

Revision 1.11  2006/09/18 20:04:27  czarny
- without kde bcond (natively uses GTK)

Revision 1.10  2006/03/13 07:32:25  glen
- use kdesu,gksu to launch smart gui

Revision 1.9  2006/03/06 19:48:31  qboosh
- pl
- existing second ksmarttray desc looks like pt(?)

Revision 1.8  2006/03/05 15:07:46  glen
- BR libstdc++-devel instead of gcc-c++

Revision 1.7  2006/03/04 20:55:10  glen
- point smart-root to smart for now

Revision 1.6  2006/03/04 15:00:05  glen
- add ksmarttray

Revision 1.5  2006/03/04 14:07:38  glen
- list files instead of generating them

Revision 1.4  2006/03/04 13:45:08  glen
- use system python-elementtree and python-cElementTree
- add /var/lib/smart dir

Revision 1.3  2006/03/04 12:32:30  glen
- added sources

Revision 1.2  2006/03/04 12:14:00  glen
- pldize

Revision 1.1  2006/03/04 12:03:14  glen
- tool for heretics
